/* Copyright (C) 2000 Hans Petter K. Jansson
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * You can contact the library's author by sending e-mail to <hpj@styx.net>.
 */

#ifndef CACHE_H
#define CACHE_H 1

#ifdef LIBFLUX_BUILD
# include "types.h"
# include "bmem.h"
#else
# include <flux/types.h>
# include <flux/bmem.h>
#endif


struct _cache_free
{
  struct _cache_free *next;
  void *data;
};


typedef struct _cache
{
  size_t elem_size;
  unsigned int elem_num;
  
  unsigned long hits, misses;

  u32 *key;
  void *data;
}
CACHE;


CACHE *cache_new(size_t elem_size, unsigned int elem_num);
void cache_del(CACHE *cache);
void cache_flush(CACHE *cache);

void cache_insert(CACHE *cache, u32 key, void *data);
void *cache_get_ptr(CACHE *cache, u32 key);
int cache_get_data(CACHE *cache, u32 key, void *dest);


#endif /* BT_H */
