/* Copyright (C) 1999-2000 Hans Petter K. Jansson
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * You can contact the library's author by sending e-mail to <hpj@styx.net>.
 */

#ifndef _RANDOM_H
#define _RANDOM_H

#ifdef LIBFLUX_BUILD
# include "types.h"
#else
# include <flux/types.h>
#endif

int rand_gather_linux(unsigned char *dest, size_t length, int level);
int rand_gather_unix(unsigned char *dest, size_t length, int level);
int rand_gather_faked(unsigned char *dest, size_t length, int level);

void rand_block(void *dest, unsigned long len, int level);
int rand_bit(int level);
byte *rand_bits_dyn(size_t num);
unsigned char rand_byte(int level);
unsigned short rand_short(int level);
unsigned long rand_long(int level);

#endif  /* _RANDOM_H */
