/* Copyright (C) 1999-2000 Hans Petter K. Jansson
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * You can contact the library's author by sending e-mail to <hpj@styx.net>.
 */

/* Used internally */

typedef struct
{
  u32  h0,h1,h2,h3,h4;
  u32  nblocks;
  byte buf[64];
  int  count;
} 
RMD160_CONTEXT;


void rmd160_init(RMD160_CONTEXT *hd);
void rmd160_write(RMD160_CONTEXT *hd, byte *inbuf, size_t inlen);
void rmd160_mixblock(RMD160_CONTEXT *hd, char *buffer);
void rmd160_final(RMD160_CONTEXT *hd);
void hash_rmd160(unsigned char *out, const unsigned char *in, size_t len);
